<?php

/*
 * Copyright (C) 2007
 * Licensed to CiviCRM under the Academic Free License version 3.0.
 *
 * Written and contributed by Ideal Solution, LLC (http://www.idealso.com)
 *
 */

/**
 * @package CRM
 * @author Marshal Newrock <marshal@idealso.com>
 * $Id: AuthorizeNet.php 9112 2007-03-30 06:50:37Z manish $
 **/

$GLOBALS['_CRM_CONTRIBUTE_PAYMENT_AUTHORIZENET']['_singleton'] =  null;

require_once 'CRM/Core/Payment/AuthorizeNet.php';

class CRM_Contribute_Payment_AuthorizeNet extends CRM_Core_Payment_AuthorizeNet {
    /** 
     * We only need one instance of this object. So we use the singleton 
     * pattern and cache the instance in this variable 
     *
     * @var object 
     * @static 
     */
    
    
    /**
     * Constructor
     *
     * @param string $mode the mode of operation: live or test
     *
     * @return void
     */
    function CRM_Contribute_Payment_AuthorizeNet( $mode ) {
        parent::CRM_Core_Payment_AuthorizeNet( $mode );
    }

    /**
     * singleton function used to manage this object
     *
     * @param string $mode the mode of operation: live or test
     *
     * @return object
     * @static
     */
     function &singleton( $mode ) {
        if ($GLOBALS['_CRM_CONTRIBUTE_PAYMENT_AUTHORIZENET']['_singleton'] === null ) {
            $GLOBALS['_CRM_CONTRIBUTE_PAYMENT_AUTHORIZENET']['_singleton'] =& new CRM_Contribute_Payment_AuthorizeNet( $mode );
        }
        return $GLOBALS['_CRM_CONTRIBUTE_PAYMENT_AUTHORIZENET']['_singleton'];
    }

}

?>